Index: trunk/sources/HeuristicLab.Logging/HeuristicLab.Logging.csproj
===================================================================
--- trunk/sources/HeuristicLab.Logging/HeuristicLab.Logging.csproj	(revision 670)
+++ trunk/sources/HeuristicLab.Logging/HeuristicLab.Logging.csproj	(revision 671)
@@ -64,4 +64,10 @@
     <Compile Include="BestAverageWorstQualityCalculator.cs" />
     <Compile Include="BestSolutionStorer.cs" />
+    <Compile Include="PointXYChartView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="PointXYChartView.Designer.cs">
+      <DependentUpon>PointXYChartView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Logger.cs" />
     <Compile Include="Linechart.cs" />
@@ -79,4 +85,6 @@
       <DependentUpon>LogView.cs</DependentUpon>
     </Compile>
+    <Compile Include="PointXYChart.cs" />
+    <Compile Include="PointXYChartInjector.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="QualityLogger.cs" />
@@ -115,4 +123,8 @@
   </ItemGroup>
   <ItemGroup>
+    <EmbeddedResource Include="PointXYChartView.resx">
+      <DependentUpon>PointXYChartView.cs</DependentUpon>
+      <SubType>Designer</SubType>
+    </EmbeddedResource>
     <EmbeddedResource Include="LinechartView.resx">
       <DependentUpon>LinechartView.cs</DependentUpon>
Index: trunk/sources/HeuristicLab.Logging/PointXYChart.cs
===================================================================
--- trunk/sources/HeuristicLab.Logging/PointXYChart.cs	(revision 671)
+++ trunk/sources/HeuristicLab.Logging/PointXYChart.cs	(revision 671)
@@ -0,0 +1,98 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Logging {
+  public class PointXYChart : ItemBase, IVisualizationItem {
+    private ItemList<ItemList<DoubleArrayData>> myValues;
+    public ItemList<ItemList<DoubleArrayData>> Values {
+      get { return myValues; }
+      set {
+        if (value != myValues) {
+          myValues = value;
+          OnValuesChanged();
+        }
+      }
+    }
+
+    private BoolData myConnectDots;
+    public BoolData ConnectDots {
+      get { return myConnectDots; }
+      set {
+        if (value != myConnectDots) {
+          myConnectDots = value;
+          OnConnectDotsChanged();
+        }
+      }
+    }
+ 
+         
+   
+    public PointXYChart() {
+      myConnectDots = new BoolData(true);
+    }
+    public PointXYChart(bool connectDots,ItemList<ItemList<DoubleArrayData>> values) {
+      myConnectDots = new BoolData(connectDots);
+      myValues = values;
+    }
+
+    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+      PointXYChart clone = (PointXYChart)base.Clone(clonedObjects);
+      clone.myValues = (ItemList<ItemList<DoubleArrayData>>)Auxiliary.Clone(Values, clonedObjects);
+      return clone;
+    }
+
+    public override IView CreateView() {
+      return new PointXYChartView(this);
+    }
+
+    public event EventHandler ValuesChanged;
+    protected virtual void OnValuesChanged() {
+      if (ValuesChanged != null)
+        ValuesChanged(this, new EventArgs());
+    }
+    public event EventHandler ConnectDotsChanged;
+    protected virtual void OnConnectDotsChanged() {
+      if (ConnectDotsChanged != null)
+        ConnectDotsChanged(this, new EventArgs());
+    }
+
+    #region Persistence Methods
+    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+      node.AppendChild(PersistenceManager.Persist("ConnectDots",ConnectDots,document,persistedObjects));
+      node.AppendChild(PersistenceManager.Persist("Values", Values, document, persistedObjects));
+      return node;
+    }
+    public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+      base.Populate(node, restoredObjects);
+      myConnectDots = (BoolData)PersistenceManager.Restore(node.SelectSingleNode("ConnectDots"), restoredObjects);
+      myValues = (ItemList<ItemList<DoubleArrayData>>)PersistenceManager.Restore(node.SelectSingleNode("Values"), restoredObjects);
+    }
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.Logging/PointXYChartInjector.cs
===================================================================
--- trunk/sources/HeuristicLab.Logging/PointXYChartInjector.cs	(revision 671)
+++ trunk/sources/HeuristicLab.Logging/PointXYChartInjector.cs	(revision 671)
@@ -0,0 +1,60 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+
+namespace HeuristicLab.Logging {
+  class PointXYChartInjector : OperatorBase {
+    public override string Description {
+      get { return @"TODO\r\nOperator description still missing ..."; }
+    }
+
+    public PointXYChartInjector() {
+      VariableInfo connectDotsInfo = new VariableInfo("ConnectDots", "Number of lines the linechart consists of", typeof(BoolData), VariableKind.In);
+      connectDotsInfo.Local = true;
+      AddVariableInfo(connectDotsInfo);
+      AddVariable(new Variable("ConnectDots", new BoolData(true)));
+      AddVariableInfo(new VariableInfo("Values", "Item list holding the values of the pointXYchart", typeof(ItemList<ItemList<DoubleArrayData>>), VariableKind.In));
+      AddVariableInfo(new VariableInfo("PointXYchart", "Object representing a pointXYchart", typeof(PointXYChart), VariableKind.New | VariableKind.Out));
+    }
+
+    public override IOperation Apply(IScope scope) {
+      bool connectDots = GetVariableValue<BoolData>("ConnectDots", scope, true).Data;
+      ItemList<ItemList<DoubleArrayData>> values = GetVariableValue<ItemList<ItemList<DoubleArrayData>>>("Values", scope, true);
+      PointXYChart pointXYchart = GetVariableValue<PointXYChart>("PointXYchart", scope, false, false);
+      if (pointXYchart == null) {
+        pointXYchart = new PointXYChart(connectDots, values);
+        IVariableInfo info = GetVariableInfo("PointXYchart");
+        if (info.Local)
+          AddVariable(new Variable(info.ActualName, pointXYchart));
+        else
+          scope.AddVariable(new Variable(scope.TranslateName(info.FormalName), pointXYchart));
+      } else
+        pointXYchart.Values = values;
+      return null;
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Logging/PointXYChartView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Logging/PointXYChartView.Designer.cs	(revision 671)
+++ trunk/sources/HeuristicLab.Logging/PointXYChartView.Designer.cs	(revision 671)
@@ -0,0 +1,79 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Logging {
+  partial class PointXYChartView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.dataChartControl = new HeuristicLab.Charting.Data.DataChartControl();
+      this.SuspendLayout();
+      // 
+      // dataChartControl
+      // 
+      this.dataChartControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.dataChartControl.BackColor = System.Drawing.SystemColors.Control;
+      this.dataChartControl.Chart = null;
+      this.dataChartControl.Location = new System.Drawing.Point(0, 0);
+      this.dataChartControl.Name = "dataChartControl";
+      this.dataChartControl.ScaleOnResize = true;
+      this.dataChartControl.Size = new System.Drawing.Size(160, 147);
+      this.dataChartControl.TabIndex = 0;
+      // 
+      // LinechartScopeView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.dataChartControl);
+      this.Name = "LinechartScopeView";
+      this.Size = new System.Drawing.Size(160, 147);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private HeuristicLab.Charting.Data.DataChartControl dataChartControl;
+
+  }
+}
Index: trunk/sources/HeuristicLab.Logging/PointXYChartView.cs
===================================================================
--- trunk/sources/HeuristicLab.Logging/PointXYChartView.cs	(revision 671)
+++ trunk/sources/HeuristicLab.Logging/PointXYChartView.cs	(revision 671)
@@ -0,0 +1,144 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Charting;
+using HeuristicLab.Charting.Data;
+
+namespace HeuristicLab.Logging {
+  public partial class PointXYChartView : ViewBase {
+    private static int[] colors = new int[] {
+      182,182,255, 
+      218,255,182,
+      255,182,218, 
+      182,255,255, 
+      218,182,255, 
+      255,182,255,
+      255,182,182, 
+      255,218,182, 
+      255,255,182, 
+      182,255,182, 
+      182,255,218, 
+      182,218,255
+    };
+
+    public PointXYChart PointXYChart {
+      get { return (PointXYChart)base.Item; }
+      set { base.Item = value; }
+    }
+
+    public PointXYChartView() {
+      InitializeComponent();
+      Caption = "PointXYChart View";
+    }
+    public PointXYChartView(PointXYChart pointXYChart)
+      : this() {
+      PointXYChart = pointXYChart;
+    }
+
+    protected override void RemoveItemEvents() {
+      if (PointXYChart != null) {
+        PointXYChart.Values.ItemAdded -= new EventHandler<ItemIndexEventArgs>(Values_ItemAdded);
+        PointXYChart.Values.ItemRemoved -= new EventHandler<ItemIndexEventArgs>(Values_ItemRemoved);
+      }
+      base.RemoveItemEvents();
+    }
+    protected override void AddItemEvents() {
+      base.AddItemEvents();
+      if (PointXYChart != null) {
+        PointXYChart.Values.ItemAdded += new EventHandler<ItemIndexEventArgs>(Values_ItemAdded);
+        PointXYChart.Values.ItemRemoved += new EventHandler<ItemIndexEventArgs>(Values_ItemRemoved);
+      }
+    }
+
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      Datachart datachart = new Datachart(-50, -5000, 1000, 55000);
+      datachart.Title = "Point X/Y Chart";
+      dataChartControl.ScaleOnResize = false;
+      dataChartControl.Chart = datachart;
+      datachart.Group.Clear();
+      datachart.Group.Add(new Axis(datachart, 0, 0, AxisType.Both));
+      double maxY = double.MinValue, minY = double.MaxValue;
+      double maxX = double.MinValue, minX = double.MaxValue;
+      if (PointXYChart != null) {
+        datachart.UpdateEnabled = false;
+        for (int i = 0; i < PointXYChart.Values.Count; i++) {
+          int colorIndex = (i % 12) * 3;
+          Color curCol = Color.FromArgb(colors[colorIndex], colors[colorIndex + 1], colors[colorIndex + 2]);
+          Pen p = new Pen(curCol);
+          SolidBrush b = new SolidBrush(curCol);
+          datachart.AddDataRow(PointXYChart.ConnectDots.Data ? DataRowType.Lines : DataRowType.Points, p, b);
+        }
+
+        for (int i = 0; i < PointXYChart.Values.Count; i++) {
+          ItemList<DoubleArrayData> list = (ItemList<DoubleArrayData>)PointXYChart.Values[i];
+          for (int j = 0; j < list.Count; j++) {
+            double[] value = ((DoubleArrayData)list[j]).Data;
+            if (!double.IsInfinity(value[0]) && !double.IsNaN(value[0]) && !double.IsInfinity(value[1]) && !double.IsNaN(value[1])) {
+              if (value[0] < minX) minX = value[0];
+              if (value[0] > maxX) maxX = value[0];
+              if (value[1] < minY) minY = value[1];
+              if (value[1] > maxY) maxY = value[1];
+
+              datachart.AddDataPoint(i, value[0], value[1]);
+            }
+          }
+        }
+        datachart.ZoomIn(minX - (minX * 0.1), minY - (minY * 0.1), maxX * 1.05 , maxY * 1.05);
+        datachart.UpdateEnabled = true;
+        datachart.EnforceUpdate();
+      }
+    }
+
+    #region Values Events
+    private delegate void ItemIndexDelegate(object sender, ItemIndexEventArgs e);
+    private void Values_ItemRemoved(object sender, ItemIndexEventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new ItemIndexDelegate(Values_ItemRemoved), sender, e);
+      } else {
+        Datachart datachart = dataChartControl.Chart;
+      }
+    }
+    private void Values_ItemAdded(object sender, ItemIndexEventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new ItemIndexDelegate(Values_ItemAdded), sender, e);
+      } else {
+        //Datachart datachart = dataChartControl.Chart;
+        //ItemList list = (ItemList)e.Item;
+        //datachart.UpdateEnabled = false;
+        //for (int i = 0; i < list.Count; i++)
+        //  datachart.AddDataPoint(i, e.Index, ((DoubleArrayData)list[i]).Data[0]);
+        //datachart.UpdateEnabled = true;
+        //datachart.EnforceUpdate();
+      }
+    }
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.Logging/PointXYChartView.resx
===================================================================
--- trunk/sources/HeuristicLab.Logging/PointXYChartView.resx	(revision 671)
+++ trunk/sources/HeuristicLab.Logging/PointXYChartView.resx	(revision 671)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>