Index: trunk/sources/HeuristicLab.Logging/PointXYChart.cs
===================================================================
--- trunk/sources/HeuristicLab.Logging/PointXYChart.cs	(revision 676)
+++ trunk/sources/HeuristicLab.Logging/PointXYChart.cs	(revision 677)
@@ -29,6 +29,6 @@
 namespace HeuristicLab.Logging {
   public class PointXYChart : ItemBase, IVisualizationItem {
-    private ItemList<ItemList<DoubleArrayData>> myValues;
-    public ItemList<ItemList<DoubleArrayData>> Values {
+    private ItemList myValues;
+    public ItemList Values {
       get { return myValues; }
       set {
@@ -56,5 +56,5 @@
       myConnectDots = new BoolData(true);
     }
-    public PointXYChart(bool connectDots,ItemList<ItemList<DoubleArrayData>> values) {
+    public PointXYChart(bool connectDots,ItemList values) {
       myConnectDots = new BoolData(connectDots);
       myValues = values;
@@ -63,5 +63,5 @@
     public override object Clone(IDictionary<Guid, object> clonedObjects) {
       PointXYChart clone = (PointXYChart)base.Clone(clonedObjects);
-      clone.myValues = (ItemList<ItemList<DoubleArrayData>>)Auxiliary.Clone(Values, clonedObjects);
+      clone.myValues = (ItemList)Auxiliary.Clone(Values, clonedObjects);
       return clone;
     }
@@ -92,5 +92,5 @@
       base.Populate(node, restoredObjects);
       myConnectDots = (BoolData)PersistenceManager.Restore(node.SelectSingleNode("ConnectDots"), restoredObjects);
-      myValues = (ItemList<ItemList<DoubleArrayData>>)PersistenceManager.Restore(node.SelectSingleNode("Values"), restoredObjects);
+      myValues = (ItemList)PersistenceManager.Restore(node.SelectSingleNode("Values"), restoredObjects);
     }
     #endregion
Index: trunk/sources/HeuristicLab.Logging/PointXYChartInjector.cs
===================================================================
--- trunk/sources/HeuristicLab.Logging/PointXYChartInjector.cs	(revision 676)
+++ trunk/sources/HeuristicLab.Logging/PointXYChartInjector.cs	(revision 677)
@@ -38,5 +38,5 @@
       AddVariableInfo(connectDotsInfo);
       AddVariable(new Variable("ConnectDots", new BoolData(true)));
-      AddVariableInfo(new VariableInfo("Values", "Item list holding the values of the pointXYchart", typeof(ItemList<ItemList<DoubleArrayData>>), VariableKind.In));
+      AddVariableInfo(new VariableInfo("Values", "Item list holding the values of the pointXYchart", typeof(ItemList), VariableKind.In));
       AddVariableInfo(new VariableInfo("PointXYchart", "Object representing a pointXYchart", typeof(PointXYChart), VariableKind.New | VariableKind.Out));
     }
@@ -44,5 +44,5 @@
     public override IOperation Apply(IScope scope) {
       bool connectDots = GetVariableValue<BoolData>("ConnectDots", scope, true).Data;
-      ItemList<ItemList<DoubleArrayData>> values = GetVariableValue<ItemList<ItemList<DoubleArrayData>>>("Values", scope, true);
+      ItemList values = GetVariableValue<ItemList>("Values", scope, true);
       PointXYChart pointXYchart = GetVariableValue<PointXYChart>("PointXYchart", scope, false, false);
       if (pointXYchart == null) {
Index: trunk/sources/HeuristicLab.Logging/PointXYChartView.cs
===================================================================
--- trunk/sources/HeuristicLab.Logging/PointXYChartView.cs	(revision 676)
+++ trunk/sources/HeuristicLab.Logging/PointXYChartView.cs	(revision 677)
@@ -99,14 +99,16 @@
 
         for (int i = 0; i < PointXYChart.Values.Count; i++) {
-          ItemList<DoubleArrayData> list = (ItemList<DoubleArrayData>)PointXYChart.Values[i];
+          ItemList list = (ItemList) PointXYChart.Values[i];
           for (int j = 0; j < list.Count; j++) {
-            double[] value = ((DoubleArrayData)list[j]).Data;
-            if (!double.IsInfinity(value[0]) && !double.IsNaN(value[0]) && !double.IsInfinity(value[1]) && !double.IsNaN(value[1])) {
-              if (value[0] < minX) minX = value[0];
-              if (value[0] > maxX) maxX = value[0];
-              if (value[1] < minY) minY = value[1];
-              if (value[1] > maxY) maxY = value[1];
+           ItemList value = ((ItemList)list[j]);
+           double x = ((DoubleData)value[0]).Data;
+           double y = ((DoubleData)value[1]).Data;
+            if (!double.IsInfinity(x) && !double.IsNaN(x) && !double.IsInfinity(y) && !double.IsNaN(y)) {
+              if (x < minX) minX = x;
+              if (x > maxX) maxX = x;
+              if (y < minY) minY = y;
+              if (y > maxY) maxY = y;
 
-              datachart.AddDataPoint(i, value[0], value[1]);                                                         
+              datachart.AddDataPoint(i, x, y);                                                         
             }
           }