Index: trunk/sources/HeuristicLab.Visualization.Test/MainForm.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization.Test/MainForm.Designer.cs	(revision 723)
+++ trunk/sources/HeuristicLab.Visualization.Test/MainForm.Designer.cs	(revision 724)
@@ -31,4 +31,5 @@
       // 
       this.canvasUI.Location = new System.Drawing.Point(12, 29);
+      this.canvasUI.MouseEventListener = null;
       this.canvasUI.Name = "canvasUI";
       this.canvasUI.Size = new System.Drawing.Size(800, 600);
@@ -45,5 +46,5 @@
       this.label2.Text = "Canvas";
       // 
-      // Form1
+      // MainForm
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
@@ -52,5 +53,5 @@
       this.Controls.Add(this.label2);
       this.Controls.Add(this.canvasUI);
-      this.Name = "Form1";
+      this.Name = "MainForm";
       this.Text = "Form1";
       this.ResumeLayout(false);
Index: trunk/sources/HeuristicLab.Visualization/CanvasUI.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/CanvasUI.Designer.cs	(revision 723)
+++ trunk/sources/HeuristicLab.Visualization/CanvasUI.Designer.cs	(revision 724)
@@ -29,5 +29,12 @@
         private void InitializeComponent()
         {
-            components = new System.ComponentModel.Container();
+          this.SuspendLayout();
+          // 
+          // CanvasUI
+          // 
+          this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.CanvasUI_MouseMove);
+          this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.CanvasUI_MouseUp);
+          this.ResumeLayout(false);
+
         }
 
Index: trunk/sources/HeuristicLab.Visualization/CanvasUI.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/CanvasUI.cs	(revision 723)
+++ trunk/sources/HeuristicLab.Visualization/CanvasUI.cs	(revision 724)
@@ -1,3 +1,5 @@
-﻿using System.Drawing;
+﻿using System;
+using System.Diagnostics;
+using System.Drawing;
 using System.Windows.Forms;
 
@@ -5,4 +7,5 @@
   public partial class CanvasUI : Control {
     private readonly Canvas mainCanvas = new Canvas();
+    private MouseEventListener mouseEventListener;
 
     public CanvasUI() {
@@ -14,14 +17,31 @@
     }
 
+    public MouseEventListener MouseEventListener {
+      get { return mouseEventListener; }
+      set { mouseEventListener = value; }
+    }
+
     protected override void OnPaint(PaintEventArgs pe) {
-      Graphics g = pe.Graphics;
+      try {
+        Graphics g = pe.Graphics;
 
-      g.FillRectangle(Brushes.White, ClientRectangle);
+        g.FillRectangle(Brushes.White, ClientRectangle);
 
-      mainCanvas.Draw(g, ClientRectangle);
+        mainCanvas.Draw(g, ClientRectangle);
 
-      g.DrawRectangle(Pens.Black, 0, 0, Width - 1, Height - 1);
+        g.DrawRectangle(Pens.Black, 0, 0, Width - 1, Height - 1);
 
-      base.OnPaint(pe);
+        base.OnPaint(pe);
+      } catch (Exception e) {
+       Debug.WriteLine(e);
+      }
+    }
+
+    private void CanvasUI_MouseMove(object sender, MouseEventArgs e) {
+      if (mouseEventListener != null) {}
+    }
+
+    private void CanvasUI_MouseUp(object sender, MouseEventArgs e) {
+      if (mouseEventListener != null) {}
     }
   }
Index: trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj
===================================================================
--- trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj	(revision 723)
+++ trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj	(revision 724)
@@ -69,5 +69,4 @@
     <Compile Include="IChartDataModel.cs" />
     <Compile Include="IChartDataRowsModel.cs" />
-    <Compile Include="IMouseEventListener.cs" />
     <Compile Include="IShape.cs" />
     <Compile Include="LineChart.cs">
@@ -77,8 +76,5 @@
       <DependentUpon>LineChart.cs</DependentUpon>
     </Compile>
-    <Compile Include="MouseEventDragDropListener.cs" />
-    <Compile Include="MouseEventPanListener.cs" />
-    <Compile Include="MouseEventSelectListener.cs" />
-    <Compile Include="MouseEventZoomListener.cs" />
+    <Compile Include="MouseEventListener.cs" />
     <Compile Include="Offset.cs" />
     <Compile Include="PointD.cs" />
Index: trunk/sources/HeuristicLab.Visualization/IMouseEventListener.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/IMouseEventListener.cs	(revision 723)
+++ 	(revision )
@@ -1,9 +1,0 @@
-﻿using System.Windows.Forms;
-
-namespace HeuristicLab.Visualization {
-  internal interface IMouseEventListener {
-    event MouseEventHandler OnMouseDown;
-    event MouseEventHandler OnMouseUp;
-    event MouseEventHandler OnMouseMove;
-  }
-}
Index: trunk/sources/HeuristicLab.Visualization/MouseEventDragDropListener.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/MouseEventDragDropListener.cs	(revision 723)
+++ 	(revision )
@@ -1,16 +1,0 @@
-﻿using System.Windows.Forms;
-
-namespace HeuristicLab.Visualization {
-  internal class MouseEventDragDropListener : IMouseEventListener{
-    #region Interface members
-
-    public event MouseEventHandler OnMouseDown;
-    public event MouseEventHandler OnMouseUp;
-    public event MouseEventHandler OnMouseMove;
-
-    #endregion
-
-    public event MouseEventHandler OnDrag;
-    public event MouseEventHandler OnDrop;
-  }
-}
Index: trunk/sources/HeuristicLab.Visualization/MouseEventListener.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/MouseEventListener.cs	(revision 724)
+++ trunk/sources/HeuristicLab.Visualization/MouseEventListener.cs	(revision 724)
@@ -0,0 +1,3 @@
+﻿namespace HeuristicLab.Visualization {
+  public class MouseEventListener {}
+}
Index: trunk/sources/HeuristicLab.Visualization/MouseEventPanListener.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/MouseEventPanListener.cs	(revision 723)
+++ 	(revision )
@@ -1,15 +1,0 @@
-﻿using System.Windows.Forms;
-
-namespace HeuristicLab.Visualization {
-  internal class MouseEventPanListener : IMouseEventListener {
-    #region Interface members
-
-    public event MouseEventHandler OnMouseDown;
-    public event MouseEventHandler OnMouseUp;
-    public event MouseEventHandler OnMouseMove;
-
-    #endregion
-
-    public event MouseEventHandler OnPan;
-  }
-}
Index: trunk/sources/HeuristicLab.Visualization/MouseEventSelectListener.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/MouseEventSelectListener.cs	(revision 723)
+++ 	(revision )
@@ -1,16 +1,0 @@
-﻿using System.Windows.Forms;
-
-namespace HeuristicLab.Visualization {
-  internal class MouseEventSelectListener : IMouseEventListener {
-    #region Interface members
-
-    public event MouseEventHandler OnMouseDown;
-    public event MouseEventHandler OnMouseUp;
-    public event MouseEventHandler OnMouseMove;
-
-    #endregion
-
-    public MouseEventHandler OnSelectionChanged;
-    public MouseEventHandler OnSelectionFinished;
-  }
-}
Index: trunk/sources/HeuristicLab.Visualization/MouseEventZoomListener.cs
===================================================================
--- trunk/sources/HeuristicLab.Visualization/MouseEventZoomListener.cs	(revision 723)
+++ 	(revision )
@@ -1,16 +1,0 @@
-﻿using System.Windows.Forms;
-
-namespace HeuristicLab.Visualization {
-  internal class MouseEventZoomListener : IMouseEventListener {
-    #region Interface members
-
-    public event MouseEventHandler OnMouseDown;
-    public event MouseEventHandler OnMouseUp;
-    public event MouseEventHandler OnMouseMove;
-
-    #endregion
-
-    public MouseEventHandler OnZoomAreaChanged;
-    public MouseEventHandler OnZoomFinished;
-  }
-}