Index: /trunk/sources/HeuristicLab.Hive.Client.Common/CommonPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Common/CommonPlugin.cs	(revision 734)
+++ /trunk/sources/HeuristicLab.Hive.Client.Common/CommonPlugin.cs	(revision 735)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
Index: /trunk/sources/HeuristicLab.Hive.Client.Common/Logging.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Common/Logging.cs	(revision 734)
+++ /trunk/sources/HeuristicLab.Hive.Client.Common/Logging.cs	(revision 735)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -6,8 +27,17 @@
 
 namespace HeuristicLab.Hive.Client.Common {
+  /// <summary>
+  /// The Logging class uses the Windows Event logging mechanism. It writes the logs to a custom log 
+  /// called "Hive Client". For the creation of the Hive Client Log the program must be executed with
+  /// Administrator privileges   
+  /// </summary>
   public class Logging {      
     private static Logging instance = null;
     private EventLog eventLogger = null;
 
+    /// <summary>
+    /// This is an implementation of the singleton design pattern.
+    /// </summary>
+    /// <returns>the instance of the logger</returns>
     public static Logging getInstance() {
       if (instance == null)
@@ -17,7 +47,12 @@
 
     private Logging() {
-      eventLogger = new EventLog("Hive Client Core");    
+      eventLogger = new EventLog("Hive Client");    
     }
 
+    /// <summary>
+    /// Writes an Info Log-Entry
+    /// </summary>
+    /// <param name="source">string representation of the caller</param>
+    /// <param name="message">the message</param>
     public void Info(String source, String message) {
       eventLogger.Source = source;
@@ -26,4 +61,9 @@
     }
 
+    /// <summary>
+    /// Writes an Error Log-Entry
+    /// </summary>
+    /// <param name="source">string representation of the caller</param>
+    /// <param name="message">the message</param>
     public void Error(String source, String message) {
       eventLogger.Source = source;
@@ -32,4 +72,10 @@
     }
 
+    /// <summary>
+    /// Writes an Error Log-Entry
+    /// </summary>
+    /// <param name="source">string representation of the caller</param>
+    /// <param name="message">the message</param>
+    /// <param name="e">the exception</param>
     public void Error(String source, String message, Exception e) {
       eventLogger.Source = source;
Index: /trunk/sources/HeuristicLab.Hive.Client.Common/MessageContainer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Common/MessageContainer.cs	(revision 734)
+++ /trunk/sources/HeuristicLab.Hive.Client.Common/MessageContainer.cs	(revision 735)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -5,4 +26,8 @@
 
 namespace HeuristicLab.Hive.Client.Common {
+  /// <summary>
+  /// The MessageContainer is a container class for Messages. Its two parts are:
+  /// the actual message itself and the JobId, refered by the message
+  /// </summary>
   public class MessageContainer {
     public MessageQueue.MessageType Message { get; set; }
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 734)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/Core.cs	(revision 735)
@@ -1,9 +1,46 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
 using System.Text;
+using HeuristicLab.Hive.Client.Common;
 
 namespace HeuristicLab.Hive.Client.Core {
   public class Core {
+    public void Start() {
+      //Logging.getInstance().Info(this.Name, "Info Message");
+      //Logging.getInstance().Error(this.Name, "Error Message");
+      //Logging.getInstance().Error(this.Name, "Exception Message", new Exception("Exception"));
+
+      Heartbeat beat = new Heartbeat();
+      beat.Interval = 1000;
+      beat.StartHeartbeat();
+      MessageQueue queue = MessageQueue.GetInstance();
+
+      while (true) {
+        MessageContainer container = queue.GetMessage();
+        Console.WriteLine(container.Message.ToString());
+      }
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/CoreApplication.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/CoreApplication.cs	(revision 734)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/CoreApplication.cs	(revision 735)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -13,20 +34,6 @@
   public class CoreApplication: ApplicationBase {
     public override void Run() {
- 
-      //Logging.getInstance().Info(this.Name, "Info Message");
-      //Logging.getInstance().Error(this.Name, "Error Message");
-      //Logging.getInstance().Error(this.Name, "Exception Message", new Exception("Exception"));
-      
-      Heartbeat beat = new Heartbeat();
-      beat.Interval = 1000;
-      beat.StartHeartbeat();
-      MessageQueue queue = MessageQueue.GetInstance();
-      
-      while (true) {
-        MessageContainer container = queue.GetMessage();
-        Console.WriteLine(container.Message.ToString());
-      }
-
-      
+      Core core = new Core();
+      core.Start();
     }
   }
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/CorePlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/CorePlugin.cs	(revision 734)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/CorePlugin.cs	(revision 735)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
Index: /trunk/sources/HeuristicLab.Hive.Client.Core/Heartbeat.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Core/Heartbeat.cs	(revision 734)
+++ /trunk/sources/HeuristicLab.Hive.Client.Core/Heartbeat.cs	(revision 735)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -7,7 +28,9 @@
 
 namespace HeuristicLab.Hive.Client.Core {
+  /// <summary>
+  /// Heartbeat class. It sends every x ms a heartbeat to the server and receives a Message
+  /// </summary>
   public class Heartbeat {
-    public double Interval { get; set; }
-    
+    public double Interval { get; set; }    
     private Timer heartbeatTimer = null;
         
@@ -20,4 +43,7 @@
     }
 
+    /// <summary>
+    /// Starts the Heartbeat signal.
+    /// </summary>
     public void StartHeartbeat() {
       heartbeatTimer = new System.Timers.Timer();
@@ -28,4 +54,9 @@
     }
 
+    /// <summary>
+    /// This Method is called every time the timer ticks
+    /// </summary>
+    /// <param name="sender"></param>
+    /// <param name="e"></param>
     void heartbeatTimer_Elapsed(object sender, ElapsedEventArgs e) {
       Console.WriteLine("tick");